Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DataSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DataSwingManager.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DataSwingManager.java	(revision 44259)
@@ -43,6 +43,7 @@
 import org.gvsig.fmap.dal.swing.featuretype.FeatureTypeAttributePanel;
 import org.gvsig.fmap.dal.swing.featuretype.FeatureTypePanel;
 import org.gvsig.fmap.dal.swing.jdbc.JDBCConnectionPanel;
+import org.gvsig.fmap.dal.swing.searchpanel.FeatureStoreSearchPanel;
 import org.gvsig.tools.dynobject.DynStruct;
 import org.gvsig.tools.swing.api.pickercontroller.PickerController;
 
@@ -90,5 +91,7 @@
     
     public FeatureTypeAttributePanel createFeatureTypeAttributePanel();    
 
-    public FeatureStoreElement createFeatureStoreElement(ExpressionBuilderConfig configPanel);
+    public FeatureStoreElement createFeatureStoreElement();
+    
+    public FeatureStoreSearchPanel createFeatureStoreSearchPanel(FeatureStore store);
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/DefaultJFeaturesForm.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/DefaultJFeaturesForm.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/DefaultJFeaturesForm.java	(revision 44259)
@@ -103,12 +103,14 @@
             return store.getResourcesStorage();
         }
         
+        @Override
         public FeatureStore getFeatureStore(String storeName) {
             return (FeatureStore) this.getDataStore(storeName);
         }
 
+        @Override
         public DataStore getDataStore(String storeName) {
-            FeatureStore theStore = (FeatureStore) store.getChild(storeName);
+            FeatureStore theStore = (FeatureStore) store.getChildren().get(storeName);
             if (theStore == null) {
                 DataManager dataManager = DALLocator.getDataManager();
                 StoresRepository repository = dataManager.getStoresRepository();
@@ -518,10 +520,12 @@
             }
         }
 
+        @Override
         public void formBeforeNew(JDynFormSet dynformSet) throws AbortActionException {
             LOGGER.trace("formBeforeNew");
         }
 
+        @Override
         public void formBeforeDelete(JDynFormSet dynformSet) throws AbortActionException {
             LOGGER.trace("formBeforeDelete");
         }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/dynformfield/selectableforeingkey/JDynFormFieldSelectableForeingKeyFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/dynformfield/selectableforeingkey/JDynFormFieldSelectableForeingKeyFactory.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/dynformfield/selectableforeingkey/JDynFormFieldSelectableForeingKeyFactory.java	(revision 44259)
@@ -24,9 +24,9 @@
 package org.gvsig.featureform.swing.impl.dynformfield.selectableforeingkey;
 
 import org.apache.commons.lang3.StringUtils;
-import static org.gvsig.featureform.swing.impl.dynformfield.selectableforeingkey.JDynFormFieldSelectableForeingKey.DAL_FOREING_CODE;
-import static org.gvsig.featureform.swing.impl.dynformfield.selectableforeingkey.JDynFormFieldSelectableForeingKey.DAL_FOREING_LABEL;
-import static org.gvsig.featureform.swing.impl.dynformfield.selectableforeingkey.JDynFormFieldSelectableForeingKey.DAL_FOREING_TABLE;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_CODE;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_LABEL;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_TABLE;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dataTypes.DataTypes;
 import org.gvsig.tools.dynform.DynFormFieldDefinition;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/dynformfield/selectableforeingkey/JDynFormFieldSelectableForeingKey.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/dynformfield/selectableforeingkey/JDynFormFieldSelectableForeingKey.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/featureform/swing/impl/dynformfield/selectableforeingkey/JDynFormFieldSelectableForeingKey.java	(revision 44259)
@@ -26,12 +26,12 @@
 import org.gvsig.expressionevaluator.Expression;
 import org.gvsig.expressionevaluator.ExpressionUtils;
 import org.gvsig.expressionevaluator.SymbolTable;
-import org.gvsig.featureform.swing.JFeatureForm;
 import org.gvsig.featureform.swing.JFeaturesForm.FeaturesFormContext;
-import org.gvsig.featureform.swing.impl.DefaultJFeaturesForm;
-import org.gvsig.featureform.swing.impl.dynformfield.linkforeingkey.JDynFormFieldForeingKey;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_CODE;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_LABEL;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_TABLE;
 import org.gvsig.fmap.dal.expressionevaluator.FeatureSymbolTable;
 import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureStore;
@@ -46,10 +46,6 @@
 @SuppressWarnings("UseSpecificCatch")
 public class JDynFormFieldSelectableForeingKey extends AbstractJDynFormFieldWithValueList implements JDynFormField {
 
-    static final String DAL_FOREING_CODE = "DAL.foreingCode";
-    static final String DAL_FOREING_TABLE = "DAL.foreingTable";
-    static final String DAL_FOREING_LABEL = "DAL.foreingLabel";
-
     public JDynFormFieldSelectableForeingKey(
             DynFormSPIManager serviceManager,
             DynFormSPIManager.ComponentsFactory componentsFactory,
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/DefaultSearchPanelView.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/DefaultSearchPanelView.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/DefaultSearchPanelView.java	(revision 44259)
@@ -0,0 +1,342 @@
+package org.gvsig.fmap.dal.swing.impl.searchpanel;
+
+import com.jeta.open.i18n.I18NUtils;
+import com.jgoodies.forms.layout.CellConstraints;
+import com.jgoodies.forms.layout.FormLayout;
+import java.awt.BorderLayout;
+import java.awt.ComponentOrientation;
+import java.awt.Container;
+import java.awt.Dimension;
+import javax.swing.Box;
+import javax.swing.ImageIcon;
+import javax.swing.JButton;
+import javax.swing.JComboBox;
+import javax.swing.JFrame;
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+import javax.swing.JScrollPane;
+import javax.swing.JTabbedPane;
+import javax.swing.JTable;
+import javax.swing.JTextField;
+import javax.swing.border.EmptyBorder;
+
+
+public class DefaultSearchPanelView extends JPanel
+{
+   JTabbedPane tabSearchMode = new JTabbedPane();
+   JComboBox cboValue1 = new JComboBox();
+   JComboBox cboValue2 = new JComboBox();
+   JComboBox cboValue3 = new JComboBox();
+   JComboBox cboValue4 = new JComboBox();
+   JLabel lblRelationalOperator1 = new JLabel();
+   JLabel lblRelationalOperator2 = new JLabel();
+   JLabel lblRelationalOperator3 = new JLabel();
+   JLabel lblRelationalOperator4 = new JLabel();
+   JLabel lblLogicalOperators1 = new JLabel();
+   JLabel lblLogicalOperators2 = new JLabel();
+   JLabel lblLogicalOperators3 = new JLabel();
+   JLabel lblField1 = new JLabel();
+   JLabel lblField2 = new JLabel();
+   JLabel lblField3 = new JLabel();
+   JLabel lblField4 = new JLabel();
+   JLabel lblExtraFields1 = new JLabel();
+   JLabel lblExtraFields2 = new JLabel();
+   JLabel lblExtraFields3 = new JLabel();
+   JLabel lblExtraFields4 = new JLabel();
+   JTextField txtAdvancedExpression = new JTextField();
+   JLabel lblExpressionDeBusqueda = new JLabel();
+   JButton btnAdvancedExpression = new JButton();
+   JButton btnSearch = new JButton();
+   JButton btnClear = new JButton();
+   JTable tblResults = new JTable();
+   JButton btnShowForm = new JButton();
+   JLabel lblMsg = new JLabel();
+
+   /**
+    * Default constructor
+    */
+   public DefaultSearchPanelView()
+   {
+      initializePanel();
+   }
+
+   /**
+    * Adds fill components to empty cells in the first row and first column of the grid.
+    * This ensures that the grid spacing will be the same as shown in the designer.
+    * @param cols an array of column indices in the first row where fill components should be added.
+    * @param rows an array of row indices in the first column where fill components should be added.
+    */
+   void addFillComponents( Container panel, int[] cols, int[] rows )
+   {
+      Dimension filler = new Dimension(10,10);
+
+      boolean filled_cell_11 = false;
+      CellConstraints cc = new CellConstraints();
+      if ( cols.length > 0 && rows.length > 0 )
+      {
+         if ( cols[0] == 1 && rows[0] == 1 )
+         {
+            /** add a rigid area  */
+            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
+            filled_cell_11 = true;
+         }
+      }
+
+      for( int index = 0; index < cols.length; index++ )
+      {
+         if ( cols[index] == 1 && filled_cell_11 )
+         {
+            continue;
+         }
+         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
+      }
+
+      for( int index = 0; index < rows.length; index++ )
+      {
+         if ( rows[index] == 1 && filled_cell_11 )
+         {
+            continue;
+         }
+         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
+      }
+
+   }
+
+   /**
+    * Helper method to load an image file from the CLASSPATH
+    * @param imageName the package and name of the file to load relative to the CLASSPATH
+    * @return an ImageIcon instance with the specified image file
+    * @throws IllegalArgumentException if the image resource cannot be loaded.
+    */
+   public ImageIcon loadImage( String imageName )
+   {
+      try
+      {
+         ClassLoader classloader = getClass().getClassLoader();
+         java.net.URL url = classloader.getResource( imageName );
+         if ( url != null )
+         {
+            ImageIcon icon = new ImageIcon( url );
+            return icon;
+         }
+      }
+      catch( Exception e )
+      {
+         e.printStackTrace();
+      }
+      throw new IllegalArgumentException( "Unable to load image: " + imageName );
+   }
+
+   /**
+    * Method for recalculating the component orientation for 
+    * right-to-left Locales.
+    * @param orientation the component orientation to be applied
+    */
+   public void applyComponentOrientation( ComponentOrientation orientation )
+   {
+      // Not yet implemented...
+      // I18NUtils.applyComponentOrientation(this, orientation);
+      super.applyComponentOrientation(orientation);
+   }
+
+   public JPanel createPanel()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE","CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,FILL:DEFAULT:GROW(1.0),CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      tabSearchMode.setName("tabSearchMode");
+      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
+      tabSearchMode.setBorder(emptyborder1);
+      tabSearchMode.setTabPlacement(JTabbedPane.BOTTOM);
+      tabSearchMode.addTab("Simplificada",null,createPanel1());
+      tabSearchMode.addTab("Avanzada",null,createPanel2());
+      jpanel1.add(tabSearchMode,cc.xy(2,2));
+
+      jpanel1.add(createPanel3(),cc.xy(2,3));
+      tblResults.setName("tblResults");
+      JScrollPane jscrollpane1 = new JScrollPane();
+      jscrollpane1.setViewportView(tblResults);
+      jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
+      jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
+      jpanel1.add(jscrollpane1,cc.xy(2,5));
+
+      jpanel1.add(createPanel4(),cc.xy(2,7));
+      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4,5,6,7,8 });
+      return jpanel1;
+   }
+
+   public JPanel createPanel1()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      cboValue1.setEditable(true);
+      cboValue1.setName("cboValue1");
+      cboValue1.setRequestFocusEnabled(false);
+      jpanel1.add(cboValue1,cc.xywh(2,6,3,1));
+
+      cboValue2.setEditable(true);
+      cboValue2.setName("cboValue2");
+      cboValue2.setRequestFocusEnabled(false);
+      jpanel1.add(cboValue2,cc.xywh(8,6,3,1));
+
+      cboValue3.setEditable(true);
+      cboValue3.setName("cboValue3");
+      cboValue3.setRequestFocusEnabled(false);
+      jpanel1.add(cboValue3,cc.xywh(14,6,3,1));
+
+      cboValue4.setEditable(true);
+      cboValue4.setName("cboValue4");
+      cboValue4.setRequestFocusEnabled(false);
+      jpanel1.add(cboValue4,cc.xywh(20,6,2,1));
+
+      lblRelationalOperator1.setName("lblRelationalOperator1");
+      lblRelationalOperator1.setText("Igual");
+      lblRelationalOperator1.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblRelationalOperator1,cc.xy(2,4));
+
+      lblRelationalOperator2.setName("lblRelationalOperator2");
+      lblRelationalOperator2.setText("Igual");
+      lblRelationalOperator2.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblRelationalOperator2,cc.xy(8,4));
+
+      lblRelationalOperator3.setName("lblRelationalOperator3");
+      lblRelationalOperator3.setText("Igual");
+      lblRelationalOperator3.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblRelationalOperator3,cc.xy(14,4));
+
+      lblRelationalOperator4.setName("lblRelationalOperator4");
+      lblRelationalOperator4.setText("Igual");
+      lblRelationalOperator4.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblRelationalOperator4,cc.xy(20,4));
+
+      lblLogicalOperators1.setName("lblLogicalOperators1");
+      lblLogicalOperators1.setText("WWWWW");
+      lblLogicalOperators1.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblLogicalOperators1,cc.xy(6,2));
+
+      lblLogicalOperators2.setName("lblLogicalOperators2");
+      lblLogicalOperators2.setText("WWWWW");
+      lblLogicalOperators2.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblLogicalOperators2,cc.xy(12,2));
+
+      lblLogicalOperators3.setName("lblLogicalOperators3");
+      lblLogicalOperators3.setText("WWWWW");
+      lblLogicalOperators3.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblLogicalOperators3,cc.xy(18,2));
+
+      lblField1.setName("lblField1");
+      lblField1.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblField1,cc.xy(2,2));
+
+      lblField2.setName("lblField2");
+      lblField2.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblField2,cc.xy(8,2));
+
+      lblField3.setName("lblField3");
+      lblField3.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblField3,cc.xy(14,2));
+
+      lblField4.setName("lblField4");
+      lblField4.setHorizontalAlignment(JLabel.CENTER);
+      jpanel1.add(lblField4,cc.xy(20,2));
+
+      lblExtraFields1.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-search-attribute-selector.png"));
+      lblExtraFields1.setName("lblExtraFields1");
+      jpanel1.add(lblExtraFields1,cc.xy(4,2));
+
+      lblExtraFields2.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-search-attribute-selector.png"));
+      lblExtraFields2.setName("lblExtraFields2");
+      jpanel1.add(lblExtraFields2,cc.xy(10,2));
+
+      lblExtraFields3.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-search-attribute-selector.png"));
+      lblExtraFields3.setName("lblExtraFields3");
+      jpanel1.add(lblExtraFields3,cc.xy(16,2));
+
+      lblExtraFields4.setIcon(loadImage("datos/devel/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/resources/org/gvsig/fmap/dal/swing/impl/searchpanel/featurestore-search-attribute-selector.png"));
+      lblExtraFields4.setName("lblExtraFields4");
+      jpanel1.add(lblExtraFields4,cc.xy(21,2));
+
+      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22 },new int[]{ 1,2,3,4,5,6,7 });
+      return jpanel1;
+   }
+
+   public JPanel createPanel2()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:4DLU:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE","CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE,CENTER:DEFAULT:NONE,CENTER:2DLU:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      txtAdvancedExpression.setName("txtAdvancedExpression");
+      jpanel1.add(txtAdvancedExpression,cc.xy(2,4));
+
+      lblExpressionDeBusqueda.setName("lblExpressionDeBusqueda");
+      lblExpressionDeBusqueda.setText("Introduzca una expresion de busqueda");
+      jpanel1.add(lblExpressionDeBusqueda,cc.xy(2,2));
+
+      btnAdvancedExpression.setActionCommand("...");
+      btnAdvancedExpression.setName("btnAdvancedExpression");
+      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
+      btnAdvancedExpression.setBorder(emptyborder1);
+      jpanel1.add(btnAdvancedExpression,cc.xy(4,4));
+
+      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5 },new int[]{ 1,2,3,4,5 });
+      return jpanel1;
+   }
+
+   public JPanel createPanel3()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      btnSearch.setActionCommand("Buscar");
+      btnSearch.setName("btnSearch");
+      btnSearch.setText("Buscar");
+      jpanel1.add(btnSearch,cc.xy(4,1));
+
+      btnClear.setActionCommand("Limpiar");
+      btnClear.setName("btnClear");
+      btnClear.setText("Limpiar");
+      jpanel1.add(btnClear,cc.xy(2,1));
+
+      addFillComponents(jpanel1,new int[]{ 1,3 },new int[]{ 1 });
+      return jpanel1;
+   }
+
+   public JPanel createPanel4()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      btnShowForm.setActionCommand("Ver");
+      btnShowForm.setName("btnShowForm");
+      btnShowForm.setText("Mostrar formulario");
+      jpanel1.add(btnShowForm,cc.xy(6,1));
+
+      lblMsg.setName("lblMsg");
+      jpanel1.add(lblMsg,cc.xy(1,1));
+
+      addFillComponents(jpanel1,new int[]{ 2,3,4,5 },new int[0]);
+      return jpanel1;
+   }
+
+   /**
+    * Initializer
+    */
+   protected void initializePanel()
+   {
+      setLayout(new BorderLayout());
+      add(createPanel(), BorderLayout.CENTER);
+   }
+
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/SearchUtils.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/SearchUtils.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/SearchUtils.java	(revision 44259)
@@ -0,0 +1,166 @@
+package org.gvsig.fmap.dal.swing.impl.searchpanel;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.List;
+import java.util.Iterator;
+import java.util.function.Predicate;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.tools.dataTypes.DataType;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.util.ChainedIterator;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class SearchUtils {
+
+    private SearchUtils() {
+
+    }
+
+    private static final RecentUsedsAttributesImpl RECENTS_USEDS = new RecentUsedsAttributesImpl();
+    
+    public static final Predicate<FeatureAttributeDescriptor> BASIC_TYPES_FILTER = new Predicate<FeatureAttributeDescriptor>() {
+        @Override
+        public boolean test(FeatureAttributeDescriptor attrdesc) {
+            DataType t = attrdesc.getDataType();
+            boolean r = !(t.isContainer() || t.isDynObject() || t.isObject());
+            return r;
+        }
+    };
+
+    public static Predicate<FeatureAttributeDescriptor> ALL_FILTER = new Predicate<FeatureAttributeDescriptor>() {
+        @Override
+        public boolean test(FeatureAttributeDescriptor t) {
+            return true;
+        }
+    };
+
+    public static final Comparator<FeatureAttributeDescriptor> LABEL_ORDER = new Comparator<FeatureAttributeDescriptor>() {
+        @Override
+        public int compare(FeatureAttributeDescriptor o1, FeatureAttributeDescriptor o2) {
+            return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
+        }
+    };
+
+    public static final Comparator<FeatureAttributeDescriptor> STR_INT_LONG_LABEL_ORDER = new Comparator<FeatureAttributeDescriptor>() {
+        @Override
+        public int compare(FeatureAttributeDescriptor o1, FeatureAttributeDescriptor o2) {
+            int t1 = o1.getType();
+            int t2 = o2.getType();
+            if( t1==DataTypes.STRING ) {
+                if( t2==DataTypes.STRING ) {
+                    return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
+                }
+                return -1;
+            } else if( t2==DataTypes.STRING ) {
+                return 1;
+            }
+            if( t1==DataTypes.INT || t1==DataTypes.LONG ) {
+                if( t2==DataTypes.INT || t2==DataTypes.LONG ) {
+                    return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
+                }
+                return -1;
+            } else if( t2==DataTypes.INT || t2==DataTypes.LONG ) {
+                return 1;
+            }
+            return StringUtils.compareIgnoreCase(o1.getLabel(), o2.getLabel());
+        }
+    };
+
+    public static List<FeatureAttributeDescriptor> getOrderedAttributes(
+            FeatureStore store,
+            Predicate<FeatureAttributeDescriptor> filter,
+            Comparator<FeatureAttributeDescriptor> comparator,
+            int max
+    ) {
+        try {
+            return getOrderedAttributes(store.getDefaultFeatureType(), filter, comparator, max);
+        } catch (DataException ex) {
+            throw new RuntimeException(ex);
+        }
+    }
+    public static List<FeatureAttributeDescriptor> getOrderedAttributes(
+            FeatureType featureType,
+            Predicate<FeatureAttributeDescriptor> filter,
+            Comparator<FeatureAttributeDescriptor> comparator,
+            int max
+    ) {
+        List<FeatureAttributeDescriptor> mostUsed = new ArrayList<>();
+        List<FeatureAttributeDescriptor> favorites = new ArrayList<>();
+        List<FeatureAttributeDescriptor> normal = new ArrayList<>();
+
+        for (FeatureAttributeDescriptor attribute : getRecentUseds().getAttributes(featureType)) {
+            if (filter.test(attribute)) {
+                mostUsed.add(attribute);
+            }
+        }
+        for (FeatureAttributeDescriptor attribute : getFavoritesAttributes(featureType)) {
+            if (contains(mostUsed, attribute.getName())) {
+                continue;
+            }
+            if (filter.test(attribute)) {
+                favorites.add(attribute);
+            }
+        }
+        for (FeatureAttributeDescriptor attribute : featureType) {
+            if (contains(mostUsed, attribute.getName())) {
+                continue;
+            }
+            if (contains(favorites, attribute.getName())) {
+                continue;
+            }
+            if (filter.test(attribute)) {
+                normal.add(attribute);
+            }
+        }
+        mostUsed.sort(comparator);
+        favorites.sort(comparator);
+        normal.sort(comparator);
+
+        if (max < 0) {
+            max = Integer.MAX_VALUE;
+        }
+        Iterator<FeatureAttributeDescriptor> it = new ChainedIterator<>(
+                mostUsed.iterator(),
+                favorites.iterator(),
+                normal.iterator()
+        );
+        List<FeatureAttributeDescriptor> r = new ArrayList<>();
+        int n = 0;
+        while (n < max && it.hasNext()) {
+            r.add(it.next());
+            n++;
+        }
+        return r;
+    }
+
+    private static boolean contains(List<FeatureAttributeDescriptor> attributes, String name) {
+        if (StringUtils.isBlank(name)) {
+            return false;
+        }
+        for (FeatureAttributeDescriptor attribute : attributes) {
+            if (StringUtils.equalsIgnoreCase(name, attribute.getName())) {
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public static RecentUsedsAttributesImpl getRecentUseds() {
+        return RECENTS_USEDS;
+    }
+    
+    public static Collection<FeatureAttributeDescriptor> getFavoritesAttributes(FeatureType featureType) {
+        return Collections.EMPTY_LIST;
+    }
+
+}
